import time
import math
import sys
import System
#
from System.Collections.Generic import List
from System import Byte, Int32
#
import common
common.Gumps = Gumps
common.Items = Items
common.Player = Player
common.Mobiles = Mobiles
#
Current_Map = Player.Map  # Note Faraan and Felucca seem the same
#
square_size=8
eightByEightX = Player.Position.X / square_size
eightByEightY = Player.Position.Y / square_size
areaToClear_X = 6
areaToClear_Y = 37
x_direction = 1
y_direction = 1
#    
from System.Collections.Generic import List
from System import Byte, Int32
#
import clr
clr.AddReference('System.Web.Extensions')
from System.Web.Script.Serialization import JavaScriptSerializer
#
#
def RangeTree( tree ):
    dist = math.sqrt( ((Player.Position.X - tree.X)**2) + ((Player.Position.Y - tree.Y)**2) )
    return dist
#
def NearestCalc(itemList):
    if len(itemList) == 0:
        return None
    min_distance_item = None
    min_distance = 99999
    for i in itemList:
        dist = RangeTree(i)
        #Misc.SendMessage("dist: {}, {} item: 0x{:x}".format(dist, Player.DistanceTo(i), i.Serial), 5)        
        if dist < min_distance:
            min_distance = dist
            min_distance_item = i            
        #Misc.SendMessage("FINAL dist: {} item: 0x{:x}".format(min_distance, min_distance_item.Serial), 5)
    return min_distance_item
#
HatchetID = 0x0F46
HatchetID2 = 0x0F45

def FindAxe():
    right = Player.GetItemOnLayer('RightHand')    
    left = Player.GetItemOnLayer('LeftHand')
    #
    #
    if left and left.ItemID == HatchetID:
        axe = left
    elif right and right.ItemID == HatchetID:
        axe = right
    else:    
        axe = Items.FindByID(HatchetID, 0, Player.Backpack.Serial)
    # if one in pack use it
    if axe:
        return axe
    if left and left.ItemID == HatchetID2:
        axe = left
    elif right and right.ItemID == HatchetID2:
        axe = right
    else:    
        axe = Items.FindByID(HatchetID2, 0, Player.Backpack.Serial)
    # if one in pack use it
    if axe:
        return axe      
    Misc.SendMessage("NO AXE", 5)
    Stop()    


TreeStaticID = [ 0xc95, 0xc96, 0xc99, 0xc9b, 0xc9c, 0xc9D, 0xc8a, 0xca6, 0xca8, 
0xcaa, 0xcab, 0xcc3, 0xcc4, 0xcc8, 0xcc9, 0xcca, 0xccb, 0xccc, 0xccd, 0xcd3, 0xcd1, 0xcd0, 0xcd6, 0xcd8, 
0xcda, 0xcdd, 0xce0, 0xce3, 0xce6, 0xcf8, 0xcf8, 0xcfe, 0xd01, 0xd25, 0xd27, 0xd35, 0xd37, 0xd38, 
0xd42, 0xd43, 0xd59, 0xd70, 0xd85, 0xd94, 0xd96, 0xd98, 0xd9a, 0xd9c, 0xd9e, 0xda0, 0xda2, 0xda04, 
0xda8, 0x0DAC, 0x0DAD ]
#
tileinfo = List[Statics.TileInfo]
#

class Tree:
    def __init__(self, x, y, z, id):
        self.X = x
        self.Y = y
        self.Z = z
        self.ID = id
        
def ScanStaticTrees(start_x, start_y): 
    Misc.SendMessage("--> Initiating Tile Scan", 77)
    trees = []
    #
    for y in range(start_y, start_y+8+1):
        for x in range(start_x, start_x+8+1):
            tileinfo = Statics.GetStaticsTileInfo(x, y, Player.Map)
            #Misc.SendMessage("X:{} Y:{} tilenum: {} map{}".format( 
            #x, y, tileinfo.Count, Player.Map))
            if tileinfo.Count > 0:
                for tile in tileinfo: 
                    if tile.StaticID in TreeStaticID:
                        #Misc.SendMessage('--> Tree X: %i - Y: %i - Z: %i' % (x, y, tile.StaticZ), 66)
                        tree = Tree(x, y, tile.StaticZ, tile.StaticID)
                        trees.append(tree)
   
    Misc.SendMessage('--> Total Trees: {}'.format(len(trees)), 77) 
    #for tree in trees:
        #Misc.SendMessage("Found tree at X:{} Y:{} Z:{} ID{}".format(tree.X, tree.Y, tree.Z, tree.ID))
    return trees

#
def CheckTreeFinished(tree):
    if Misc.CheckSharedValue("StaticTrees"):
        return Journal.Search("not enough wood here")
    else:    
        check_tree = Items.FindBySerial(tree.Serial)
        if check_tree == None:
            return True
        else:
            return False
#
def ConvertLogsToWood():
    axe = FindAxe()
    if not axe:
        Misc.SendMessage("Unable to Find suitable Axe")
        Stop()
    logID = 0x1BDD
    logs = common.findRecursive(Player.Backpack.Serial, [ logID ])
    for log in logs:
        #Misc.SendMessage("{} 0x{:x} - 0x{:x}".format(wood.Name, prev_wood, wood.Serial), 5)
        Items.UseItem(axe)
        Target.WaitForTarget(1000, False)
        #Misc.SendMessage("0x{:x}".format(log.Serial), 5)
        Target.TargetExecute(log)
        Misc.Pause(1000)
        #

#    
def MoveWoodToBOH():
    # Move to Packhorse or BagOfHolding       
    woodID = 0x1BD7
    BOH = Misc.ReadSharedValue("BagOfHolding")
    fletchingTools = 0x1022
    barkFragment = 0x318F
    switches = 0x2F5F
    parasiticPlant = 0x3190
    luminesentFungus = 0x3191
    artiBags = 0x0E76
    #Items.FindByID(woodID, -1, Player.Backpack.Serial) 
    woods = common.findRecursive(Player.Backpack.Serial, [ woodID, fletchingTools, barkFragment, switches, parasiticPlant, luminesentFungus, artiBags ])
    prev_wood = 0  
    max_tries = 10 
    for wood in woods:
        if wood.Container != BOH:
            #Misc.SendMessage("{} 0x{:x} - 0x{:x}".format(wood.Name, prev_wood, wood.Serial), 5)
            Items.Move(wood.Serial, BOH, 0)
            Misc.Pause(1000)

#           
if areaToClear_X < 0:
    x_direction = -1
if areaToClear_Y < 0:
    y_direction = -1
#
axe = Player.GetItemOnLayer('LeftHand')
if not axe:
    axe = FindAxe()
    if not axe:
        Misc.SendMessage("Unable to Find suitable Axe")
        stop()

for ebe_x in range(eightByEightX, eightByEightX+areaToClear_X, x_direction):
    for ebe_y in range(eightByEightY, eightByEightY+areaToClear_Y, y_direction):
        Misc.SendMessage("NEW 8x8 X: {} Y: {} Z: {}".format(ebe_x*square_size, ebe_y*square_size, 0))
        #Player.PathFindTo(ebe_x*square_size, ebe_y*square_size, 0)
        trees = ScanStaticTrees(ebe_x*square_size, ebe_y*square_size)
        while trees != None and len(trees) > 0:
            # In theory only 1 tree in this 8x8 will have logs
            tree = NearestCalc(trees)
            Dress.ChangeList("lj_regular")
            Dress.DressFStart()
            #Misc.SendMessage("TREE FOUND X:{} Y:{} Z:{}".format(tree.X, tree.Y, tree.Z))
            while (None != tree):
                ConvertLogsToWood()
                Misc.WaitForContext(0x4019C3ED, 2000)
                Misc.ContextReply(0x4019C3ED, "Refill from stock")
                Misc.Pause(1000)
                MoveWoodToBOH()
                wait_secs = 0
                #Player.PathFindTo(tree.X, tree.Y, tree.Z)
                route = PathFinding.Route()
                route.X = tree.X - 1
                route.Y = tree.Y - 1
                route.MaxRetry = 5
                PathFinding.Go(route)
                if RangeTree(tree) > 2:
                    Misc.Pause(1000)
                    wait_secs = wait_secs + 1
                    if wait_secs > 20:
                        Misc.SendMessage("SKIPPING Tree Location ( {}, {}, {})".format(tree.Position.X, tree.Position.Y, tree.Position.Z), 5)
                        continue
                wood_to_chop = True
                Journal.Clear()      
                while wood_to_chop:
                    axe = FindAxe()
                    failed_chop_time = time.time() + 3
                    Misc.Pause(1000)
                    Target.Cancel
                    thing = Player.GetItemOnLayer("LeftHand")
                    if thing.Serial != axe.Serial:
                        Player.UnEquipItemByLayer("LeftHand")
                        Misc.Pause(1000)
                        Player.EquipItem(axe)
                        Misc.Pause(1000)
                    Items.UseItem(axe)
                    Target.WaitForTarget(1000, False)
                    #Misc.SendMessage("0x{:x}".format(tree.Serial), 5)
                    #Misc.SendMessage("Chop Tree at X:{} Y:{} Z:{} Tile:{}".format(tree.X, tree.Y, tree.Z, tree.ID))
                    Target.TargetExecute(tree.X, tree.Y, tree.Z, tree.ID)
                    Misc.Pause(1000)
                    Misc.Pause(1000)                  
                    if CheckTreeFinished(tree):
                        Misc.SendMessage("Stopping due to finished")
                        wood_to_chop = False                        
                    if Journal.Search("You must wait"):
                        Misc.Pause(3000)
                    if Journal.Search("You put") or Journal.Search("You put"):
                        failed_chop_time = time.time() + 6
                    if Journal.Search("no more wood"):
                        Misc.SendMessage("Stopping due to Journal")
                        wood_to_chop = False
                    if Player.Weight > Player.MaxWeight * .95:
                        Misc.SendMessage("Stopping due to Player Weight")
                        wood_to_chop = False
                    if Journal.Search("Can't get there"):
                        Misc.SendMessage("Stopping due to Unreachable")
                        #all comeMisc.CheckIgnoreObject(tree)
                        wood_to_chop = False    
                    if Journal.Search("far away"):
                        Misc.SendMessage("Stopping due to Unreachable")
                        #Misc.IgnoreObject(tree)
                        wood_to_chop = False
                    if Journal.Search("lack the skill"):
                        Misc.SendMessage("Stopping due to lack of skill")
                        #Misc.IgnoreObject(tree)
                        wood_to_chop = False    
                    if Journal.Search("cannot be seen"):
                        Misc.SendMessage("Stopping due to lack of visibility")
                        #Misc.IgnoreObject(tree)
                        wood_to_chop = False  
                    if Journal.Search("can't use an axe"):
                        Misc.SendMessage("Stopping due to invalid target")
                        #Misc.IgnoreObject(tree)
                        wood_to_chop = False                     
                    if Journal.Search("You broke your axe"):
                        axe = FindAxe()
                        if axe:
                            failed_chop_time = time.time() + 6
                            wood_to_chop = True
                        else:
                            Misc.SendMessage("Cannot find a new axe")
                            wood_to_chop = False
                    if failed_chop_time <= time.time():
                        Misc.SendMessage("Stopping due to Time-out")
                        #Misc.IgnoreObject(tree)
                        wood_to_chop = False
                    claimfilter = Items.Filter()
                    claimfilter.Enabled = True
                    claimfilter.IsCorpse = True
                    claimfilter.OnGround = True
                    claimfilter.Movable = False
                    claimfilter.RangeMax = 4
                    claimer = Items.ApplyFilter(claimfilter)
                    if len(claimer) > 0:    
                        Player.ChatSay(54, "[loot")     
                Player.ChatSay(54, "[loot")        
                #trees = FindTrees()
                trees.Remove(tree)
                #Misc.SendMessage(str(len(trees)), 5)
                tree = NearestCalc(trees)

#                    
